#!/usr/bin/env python2
import time
import os
import hashlib
import math

# config from config file
Length_Oper=5
Length_Lat=9
Length_Lon=9
Length_TargetCode=8
Length_Biscuit=8
InputTimeOut=60
DEBUG=1                      #debug
TargetVerify=""


# read number of warheads available
F = open('/home/alarm/warheads','r')
BOB = F.readline()
F.close
Warheads=int(BOB)



#images for silos
silo=[0]*10
silo[0] = pygame.image.load("/home/alarm/images/05.jpg")
silo[1] = pygame.image.load("/home/alarm/images/01.jpg")
silo[2] = pygame.image.load("/home/alarm/images/02.jpg")
silo[3] = pygame.image.load("/home/alarm/images/03.jpg")
silo[4] = pygame.image.load("/home/alarm/images/04.jpg")
silo[5] = pygame.image.load("/home/alarm/images/05.jpg")
silo[6] = pygame.image.load("/home/alarm/images/06.jpg")
silo[7] = pygame.image.load("/home/alarm/images/07.jpg")
silo[8] = pygame.image.load("/home/alarm/images/08.jpg")
silo[9] = pygame.image.load("/home/alarm/images/09.jpg")




#game state
defcon=5
game_phase=0
CurrentTime=0
TimeOfLaunch=0
LaunchMode="Drill"
DrillCode=0
LiveCode=0
EXIT=0
HITMISS=0



#inputs from user
Oper=""
LatUser="+0000000"
LonUser="+0000000"
TargetCode=""
Biscuit=""




# base colors
BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
GREEN = (  0, 255,   0)
RED = (  255, 0,   0)


# defcon colors
D1l = (  128, 0,   0)
D1h = (  255, 0,   0)
D2l = (  128, 70,   0)
D2h = (  255, 140,   0)
D3l = (  128, 128,   0)
D3h = (  255, 255,   0)
D4l = (  0, 0,   64)
D4h = (  0, 0,   255)
D5l = (  0, 128,   0)
D5h = (  0, 255,   0)

buffer=[]

key_SW1=0
key_SW2=0
Button_SW1=0
Button_SW2=0

#last key press time
Last_Key_Time=0

keyscan={
(3,7):"7",
(3,11):"8",
(3,13):"9",
(3,15):"E", # Enter
(3,19):"N", # Negate
(3,21):"0",
(3,23):"",
(3,29):"",
(5,7):"4",
(5,11):"5",
(5,13):"6",
(5,15):"X", # cancel
(5,19):"1",
(5,21):"2",
(5,23):"3",
(5,29):"C"    # Clear
}

GPIO.setmode(GPIO.BOARD)

# keypad setup
GPIO.setup(3, GPIO.OUT)
GPIO.setup(5, GPIO.OUT)
GPIO.setup(7, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(11, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(13, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(15, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(19, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(21, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(23, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(29, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)

#launch buttons setup
GPIO.setup(33, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(37, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
#launch keys setup
GPIO.setup(31, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
GPIO.setup(35, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)


#setup light of master go button
GPIO.setup(36, GPIO.OUT)
GPIO.setup(38, GPIO.OUT)
GPIO.output(36, False)  # light is off
GPIO.output(38, True)  # button trigger is on
GPIO.setup(40, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)  # button input


#setup for keypad scanning
GPIO.output(3, True)
GPIO.output(5, True)



def sigint_handler(signum, frame):
	global EXIT
	EXIT=1

signal.signal(signal.SIGTERM, sigint_handler)
signal.signal(signal.SIGINT, sigint_handler)



def DidWeHit():
	global HITMISS
	D=Distance(LatUser,LonUser,LatTarget,LonTarget) 
	if(D<0.01):
		HITMISS=1
	else:
		HITMISS=0
	if(LaunchMode=="Drill"):
		HITMISS=HITMISS+10





def setup_fonts():

	defcon_font = pygame.font.Font(None, 22)
	defcon_text = defcon_font.render("DEFCON", 1, WHITE)
	status_text = defcon_font.render("Status", 1, WHITE)

	Defcon_number_font = pygame.font.Font(None, 72)
	defcon_1 = Defcon_number_font.render("1", 1, BLACK)
	defcon_2 = Defcon_number_font.render("2", 1, BLACK)
	defcon_4 = Defcon_number_font.render("4", 1, BLACK)
	defcon_5 = Defcon_number_font.render("5", 1, BLACK)

	country_font = pygame.font.Font(None, 72)
        country = country_font.render(Country+" Launch Control", 1, WHITE)

	input_font = pygame.font.Font(None, 32)
        input_oper_text = input_font.render("Input Operater code: ", 1, WHITE)
        input_lat_text = input_font.render("Input Target Latitude: ", 1, WHITE)
        input_lon_text = input_font.render("Input Target Longitude: ", 1, WHITE)
        LaunchVerifyFail_text = input_font.render("Authentication Invalid!", 1, RED)

        destroyed_text = input_font.render("Target destroyed!", 1, WHITE)
        missed_text = input_font.render("Target missed!", 1, WHITE)

        DrillFail_text = input_font.render("You have Failed the drill!", 1, RED)
        DrillPass_text = input_font.render("You have passed the drill!", 1, WHITE)

	Geek_Font = pygame.font.Font(None, 22)




def game_state():

	#input the operator code
	if(game_phase==1):
		if(buffer[-1]=="E"):
			del buffer[-1]
			if (len(buffer)>0):
				Oper=''.join(buffer)[:Length_Oper]	
				del buffer[:]
				game_phase=10
				defcon=4
				return
		if(buffer[-1]=="N"):
			del buffer[-1]
		if(len(buffer)>Length_Oper):
			del buffer[-1]
		return


	#input the latitude
	if(game_phase==10):
		if(not buffer[0]=="-")and(not buffer[0]=="+"):
			buffer.insert(0,"+")
		if(buffer[-1]=="E"):
			del buffer[-1]
			if (len(buffer)>0):
				LatUser=''.join(buffer)[:Length_Lat]
				Q=Length_Lat-len(LatUser)
				LatUser=LatUser+"00000000"[:Q]
				del buffer[:]
				game_phase=15
				return
		if(buffer[-1]=="N"):
			del buffer[-1]
			if(buffer[0]=="+"):
				buffer[0]="-"
			else:
				buffer[0]="+"
		if(len(buffer)>Length_Lat):
			del buffer[-1]
		return



	#input the longitude
	if(game_phase==15):
		if(not buffer[0]=="-")and(not buffer[0]=="+"):
			buffer.insert(0,"+")
		if(buffer[-1]=="N"):
			del buffer[-1]
			if(buffer[0]=="+"):
				buffer[0]="-"
			else:
				buffer[0]="+"
		if(buffer[-1]=="E"):
			del buffer[-1]
			if (len(buffer)>0):
				LonUser=''.join(buffer)[:Length_Lon]
				Q=Length_Lon-len(LonUser)
				LonUser=LonUser+"000000000"[:Q]
				del buffer[:]
				game_phase=20
				defcon=3
				return
		if(len(buffer)>Length_Lon):
			del buffer[-1]
		return




	#input the TargetCode  verify target code
	if(game_phase==20):
		Drill = hashlib.md5("Drill"+LatUser+LonUser).hexdigest()
		Live = hashlib.md5("Live"+LatUser+LonUser).hexdigest()
		DrillCode = str(int(Drill,16))[:8]
		LiveCode = str(int(Live,16))[:8]
		if(buffer[-1]=="E"):
			del buffer[-1]
			if (len(buffer)>0):
				TargetCode=''.join(buffer)[:Length_TargetCode]
				del buffer[:]
				if(TargetCode==DrillCode):
					game_phase=25
					defcon=2
					LaunchMode="Drill"
				elif(TargetCode==LiveCode):
					game_phase=25
					defcon=2
					LaunchMode="Live"
				else:
					game_phase=27
		if(len(buffer)>0):
			if(buffer[-1]=="N"):
				del buffer[-1]
		if(len(buffer)>Length_TargetCode):
			del buffer[-1]
		return



	#input the Biscuit code
	if(game_phase==25):
		if(buffer[-1]=="E"):
			del buffer[-1]
			if (len(buffer)>0):
				Biscuit=''.join(buffer)[:Length_Biscuit]
				del buffer[:]
				if(Biscuit==Responce):
					if(LaunchMode=="Drill"):
						game_phase=30
						defcon=2
					if(LaunchMode=="Live"):
						game_phase=31
						defcon=2
				else:
					game_phase=33
		if(len(buffer)>0):
			if(buffer[-1]=="N"):
				del buffer[-1]
		if(len(buffer)>Length_Biscuit):
			del buffer[-1]
		return


	#Take no input during keys phase of game
	if(game_phase==30):
		del buffer[-1]
		return




def SetLaunchButtonA(inputpin):
	global game_phase
	global Button_SW1
	global Button_SW2
	global defcon
	if(game_phase==30):
		if (GPIO.input(33)):
			Button_SW1=time.time()
			print(str(game_phase)+"  Button A acvite")
		else:
			Button_SW1=0
			print(str(game_phase)+"  Button A clear")
	if (game_phase==30)and(GPIO.input(33))and(GPIO.input(37)):
		if (abs(Button_SW1 - Button_SW2) <0.2):
			#light button
			game_phase=40
			defcon=1
			print(abs(Button_SW1 - Button_SW2))
			GPIO.output(36, True)


def SetLaunchButtonB(inputpin):
	global game_phase
	global Button_SW1
	global Button_SW2
	global defcon
	if(game_phase==30):
		if (GPIO.input(37)):
			Button_SW2=time.time()
			print(str(game_phase)+"   Button B active")
		else:
			Button_SW2=0
			print(str(game_phase)+"   Button B clear")
	if (game_phase==30)and(GPIO.input(33))and(GPIO.input(37)):
		if (abs(Button_SW1 - Button_SW2) <0.2):
			#light button
			game_phase=40
			defcon=1
			print(abs(Button_SW1 - Button_SW2))
			GPIO.output(36, True)




def SetLaunchKeyA(inputpin):
	global game_phase
	global key_SW1
	global key_SW2
	global defcon
	global KeyTimer
	if(game_phase==31):
		if (GPIO.input(31)):
			key_SW1=time.time()
			print(str(game_phase)+"  key A acvite")
		else:
                     	key_SW1=0
			print(str(game_phase)+"  key A clear")
	if (game_phase==31)and(GPIO.input(31))and(GPIO.input(35)):
		if (abs(key_SW1 - key_SW2) <KeyTimer):
			#light button
			game_phase=40
			defcon=1
			print(abs(key_SW1 - key_SW2))
			GPIO.output(36, True)


def SetLaunchKeyB(inputpin):
	global game_phase
	global key_SW1
	global key_SW2
	global defcon
	global KeyTimer
	if(game_phase==31):
		if (GPIO.input(35)):
			key_SW2=time.time()
			print(str(game_phase)+"   key B active")
		else:
                     	key_SW2=0
			print(str(game_phase)+"   key B clear")
	if (game_phase==31)and(GPIO.input(31))and(GPIO.input(35)):
		if (abs(key_SW1 - key_SW2) <KeyTimer):
			#light button
			game_phase=40
			defcon=1
			print(abs(key_SW1 - key_SW2))
			GPIO.output(36, True)




def GoButton(inputpin):
	global TimeOfLaunch
	global game_phase
	global Warheads
	global LaunchMode
	if(game_phase==40):
		if (GPIO.input(40)):
			if(LaunchMode=="Live"):
				Warheads=Warheads-1
				F = open('warheads','w')
				F.write(str(Warheads))
				F.close
			Boom()
			GPIO.output(36, False)
			game_phase=50
			TimeOfLaunch=datetime.now()
			DidWeHit()





def putbuffer(row,col):
	global game_phase
	global buffer
	global defcon
	global Oper
	global LatUser
	global InputTimeOut
	global LonUser
	global Last_Key_Time
	Last_Key_Time=time.time()
	print("Row: "+str(row)+"    Col: "+str(col))
	buffer.append(keyscan[(row,col)])
	game_state() #go an update the game state
	if(row==5)and(col==29): # if clear
		del buffer[:]
	if(not game_phase==50)and(row==5)and(col==15): # if cancel
		del buffer[:]
		game_phase=1
		InputTimeOut=60
		defcon=5
		Oper=""
		LonUser="00000000"
		LatUser="00000000"


def ScanKeyboard(inputpin):
	GPIO.output(3, False)
	GPIO.output(5, False)
	for I in [3,5]:
		GPIO.output(I, True)
		for J in [7,11,13,15,19,21,23,29]:
			if GPIO.input(J):
				Beep()
				putbuffer(I,J)
				while(GPIO.input(J)):
					continue
		GPIO.output(I, False)
	GPIO.output(3,True)
	GPIO.output(5,True)





def DrawFrame():
	global country
	SCREEN.fill(BLACK)

	pygame.draw.line(SCREEN, WHITE, (5, 5), (SX, 5), 1 )
	pygame.draw.line(SCREEN, WHITE, (5, SY), (SX, SY), 1 )
	pygame.draw.line(SCREEN, WHITE, (5, 5), (5, SY), 1 )
	pygame.draw.line(SCREEN, WHITE, (SX, 5), (SX, SY), 1 )
	pygame.draw.line(SCREEN, WHITE, (5, 105), (SX, 105),1 )
        pygame.draw.line(SCREEN, WHITE, (165, 105), (165, SY), 1 )

        country_pos = country.get_rect()
        country_pos.centery = 65
        country_pos.centerx = SCREEN.get_rect().centerx
        SCREEN.blit(country, country_pos)




def DrawDefcon():
        global defcon_text
        global status_text

        global defcon_1
        global defcon_2
        global defcon_3
        global defcon_4
        global defcon_5

        SCREEN.blit(defcon_text, (55,110))
        SCREEN.blit(status_text, (60,125))

	if defcon==5 :
       		pygame.draw.rect(SCREEN,D5h, (30,150, 100,100))
       		pygame.draw.rect(SCREEN,WHITE, (30,150, 100,100),3)
        else:
       		pygame.draw.rect(SCREEN,D5l, (30,150, 100,100))

        if defcon==4 :
       		pygame.draw.rect(SCREEN,D4h, (30,150+(110*1), 100,100))
       		pygame.draw.rect(SCREEN,WHITE, (30,150+(110*1), 100,100),3)
        else:
       		pygame.draw.rect(SCREEN,D4l, (30,150+(110*1), 100,100))

	if defcon==3 :
       		pygame.draw.rect(SCREEN,D3h, (30,150+(110*2), 100,100))
       		pygame.draw.rect(SCREEN,WHITE, (30,150+(110*2), 100,100),3)
        else:
       		pygame.draw.rect(SCREEN,D3l, (30,150+(110*2), 100,100))

        if defcon==2 :
       		pygame.draw.rect(SCREEN,D2h, (30,150+(110*3), 100,100))
       		pygame.draw.rect(SCREEN,WHITE, (30,150+(110*3), 100,100),3)
        else:
       		pygame.draw.rect(SCREEN,D2l, (30,150+(110*3), 100,100))

	if defcon==1 :
       		pygame.draw.rect(SCREEN,D1h, (30,150+(110*4), 100,100))
       		pygame.draw.rect(SCREEN,WHITE, (30,150+(110*4), 100,100),3)
        else:
       		pygame.draw.rect(SCREEN,D1l, (30,150+(110*4), 100,100))

	SCREEN.blit(defcon_5, (65,175))
        SCREEN.blit(defcon_4, (65,(175+(110*1))))
        SCREEN.blit(defcon_3, (65,(175+(110*2))))
        SCREEN.blit(defcon_2, (65,(175+(110*3))))
        SCREEN.blit(defcon_1, (65,(175+(110*4))))





def Draw_Geek():
	global Oper
	global LatUser
	global LonUser
	global Satellites
	global Geek_Font
	global Voltage
	global Temperature
	global Warheads
	global GameWarheads

        buffer_text = Geek_Font.render("Operator: "+Oper, 1, GREEN)
        SCREEN.blit(buffer_text, (260,425))

        buffer_text = Geek_Font.render("Latitude: "+LatUser[:4]+"."+LatUser[4:], 1, GREEN)
        SCREEN.blit(buffer_text, (260,450))

        buffer_text = Geek_Font.render("longitude: "+LonUser[:4]+"."+LonUser[4:], 1, GREEN)
        SCREEN.blit(buffer_text, (260,475))

        buffer_text = Geek_Font.render("Satellites in range: "+str(Satellites)[:1], 1, GREEN)
        SCREEN.blit(buffer_text, (260,500))

        buffer_text = Geek_Font.render("System Voltage: "+str(Voltage)[:4], 1, GREEN)
        SCREEN.blit(buffer_text, (260,525))

        buffer_text = Geek_Font.render("Temperature: "+str(Temperature)[:4], 1, GREEN)
        SCREEN.blit(buffer_text, (260,550))

        buffer_text = Geek_Font.render("Warheads ready: "+str(Warheads), 1, GREEN)
        SCREEN.blit(buffer_text, (260,575))


#display silo camaras
	SCREEN.blit(silo[Cam_NumA],(500,500))
	SCREEN.blit(silo[Cam_NumB],(750,500))
	SCREEN.blit(silo[Cam_NumC],(1000,500))




def update_screen():

	DrawFrame()
	DrawDefcon()
	Draw_Geek()

#time calculations for frame speed and also sleep mode
	LastTime=CurrentTime
	CurrentTime=time.time()
	TimeDiff=CurrentTime-LastTime
	Speed=1/TimeDiff
	
# if key timeout then reset all game state
	if(abs(CurrentTime - Last_Key_Time)>InputTimeOut):
		InputTimeOut=60
		game_phase=0
		defcon=5
		Oper=""
		LatUser="00000000"
		LonUser="00000000"



	# INPUT dialog box
	if(game_phase==1):
		XSIZE=400
		TT=((1270-XSIZE)/2)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,80),3)
		SCREEN.blit(input_oper_text, (TT+20,300+30))
		buffer_font = pygame.font.Font(None, 42)
		buffer_text = buffer_font.render(''.join(buffer), 1, WHITE)
		SCREEN.blit(buffer_text, (TT+260,300+29))

	if(game_phase==10):
		XSIZE=460
		TT=((1270-XSIZE)/2)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,80),3)
		SCREEN.blit(input_lat_text, (TT+20,300+30))
		buffer_font = pygame.font.Font(None, 42)
		lat_text=''.join(buffer)
		buffer_text = buffer_font.render(lat_text[:4]+"."+lat_text[4:], 1, WHITE)
		SCREEN.blit(buffer_text, (TT+260,300+29))

	if(game_phase==15):
		XSIZE=460
		TT=((1270-XSIZE)/2)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,80),3)
		SCREEN.blit(input_lat_text, (TT+20,300+30))
		buffer_font = pygame.font.Font(None, 42)
		lon_text=''.join(buffer)
		buffer_text = buffer_font.render(lon_text[:4]+"."+lon_text[4:], 1, WHITE)
		SCREEN.blit(buffer_text, (TT+260,300+29))

	if(game_phase==20):
		XSIZE=460
		TT=((1270-XSIZE)/2)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,80),3)
		SCREEN.blit(input_TargetCode_text, (TT+20,300+30))
		buffer_font = pygame.font.Font(None, 42)
		TargetCode=''.join(buffer)
		buffer_text = buffer_font.render(TargetCode, 1, WHITE)
		SCREEN.blit(buffer_text, (TT+305,300+29))

	if(game_phase==27):
		XSIZE=290
		TT=((1270-XSIZE)/2)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,80),3)
		SCREEN.blit(TargetVerifyFail_text, (TT+20,300+30))

	if(game_phase==25):
		XSIZE=460
		TT=((1270-XSIZE)/2)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,120),3)
		buffer_font = pygame.font.Font(None, 42)
		buffer_text = buffer_font.render("Challange Code: "+Challange, 1, WHITE)
		SCREEN.blit(buffer_text, (TT+20,300+30))
		ChallangeCode=''.join(buffer)
		buffer_text = buffer_font.render("Authorisation: "+ChallangeCode, 1, WHITE)
		SCREEN.blit(buffer_text, (TT+20,300+60))

	if(game_phase==30):
		XSIZE=295
		TT=((1270-XSIZE)/2)
		buffer_font = pygame.font.Font(None, 42)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,80),3)
		buffer_text = buffer_font.render("Button time", 1, WHITE)
		SCREEN.blit(buffer_text, (TT+20,300+30))

	if(game_phase==31):
		XSIZE=295
		TT=((1270-XSIZE)/2)
		buffer_font = pygame.font.Font(None, 42)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,80),3)
		buffer_text = buffer_font.render("Insert Keys", 1, WHITE)
		SCREEN.blit(buffer_text, (TT+20,300+30))

	if(game_phase==33):
		XSIZE=295
		TT=((1270-XSIZE)/2)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,80),3)
		SCREEN.blit(LaunchVerifyFail_text, (TT+20,300+30))

	if(game_phase==50):
		InputTimeOut=60*16
		XSIZE=460
		TT=((1270-XSIZE)/2)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,120),3)
		CurrentTime=time.time()
		buffer_font = pygame.font.Font(None, 42)
		D = TimeOfLaunch + timedelta(days=0, hours=0, minutes=14, seconds=0)
		C = D - datetime.now()
		if("0:00:00"==str(C)[:7]):   # count down gets to zero
			game_phase=60

		buffer_text = buffer_font.render("Time To Impact: "+str(C)[:10], 1, WHITE)
		SCREEN.blit(buffer_text, (TT+20,300+30))


	if(game_phase==60):
		XSIZE=295
		TT=((1270-XSIZE)/2)
		pygame.draw.rect(SCREEN,WHITE,(TT,300,XSIZE,80),3)
		if(HITMISS==1):
			SCREEN.blit(destroyed_text, (TT+20,300+30))
		if(HITMISS==0):	
			SCREEN.blit(missed_text, (TT+20,300+30))
		if(HITMISS==11):
			SCREEN.blit(DrillPass_text, (TT+20,300+30))
		if(HITMISS==10):	
			SCREEN.blit(DrillFail_text, (TT+20,300+30))



	# DEBUG frame rate code
	if(DEBUG==1):
		buffer_font = pygame.font.Font(None, 42)
		buffer_text = buffer_font.render(str(Speed)[:4],1,WHITE)
		SCREEN.blit(buffer_text, (50,25))




def Update_Geek():
	global Satellites
	global Voltage
	global Temperature
	global Cam_NumA
	global Cam_NumB
	global Cam_NumC
	Satellites=6-(math.sin(time.time()/10)*2)+math.sin(time.time()/80)
	Voltage=25-(math.sin(time.time()/110)/2)+(math.sin(time.time()/100)/2)
	Temperature=22-(math.sin(time.time()/1200)*2)+math.sin(time.time()/720)
	Cam_NumA=int(round((time.time()/Cam_Speed)%9))
	Cam_NumB=(Cam_NumA+1)%9
	Cam_NumC=(Cam_NumB+1)%9



def main():
	global game_phase
	global EXIT
	pygame.init()
	print(pygame.display.list_modes())
	SCREEN = pygame.display.set_mode((1280, 720))
	SX=1270
	SY=710
	pygame.mouse.set_visible(False)

	setup_fonts() 

	game_phase=0
	GPIO.add_event_detect(7, GPIO.RISING, callback=ScanKeyboard, bouncetime=200)
	GPIO.add_event_detect(11, GPIO.RISING, callback=ScanKeyboard, bouncetime=200)
	GPIO.add_event_detect(13, GPIO.RISING, callback=ScanKeyboard, bouncetime=200)
	GPIO.add_event_detect(15, GPIO.RISING, callback=ScanKeyboard, bouncetime=200)
	GPIO.add_event_detect(19, GPIO.RISING, callback=ScanKeyboard, bouncetime=200)
	GPIO.add_event_detect(21, GPIO.RISING, callback=ScanKeyboard, bouncetime=200)
	GPIO.add_event_detect(23, GPIO.RISING, callback=ScanKeyboard, bouncetime=200)
	GPIO.add_event_detect(29, GPIO.RISING, callback=ScanKeyboard, bouncetime=200)
	
	GPIO.add_event_detect(33, GPIO.BOTH, callback=SetLaunchButtonA, bouncetime=30)
	GPIO.add_event_detect(37, GPIO.BOTH, callback=SetLaunchButtonB, bouncetime=30)

	GPIO.add_event_detect(31, GPIO.BOTH, callback=SetLaunchKeyA, bouncetime=30)
	GPIO.add_event_detect(35, GPIO.BOTH, callback=SetLaunchKeyB, bouncetime=30)
	
	GPIO.add_event_detect(40, GPIO.RISING, callback=GoButton, bouncetime=30)

	while(EXIT==0):
		Update_Geek()
		update_screen()
		pygame.display.update()

	GPIO.cleanup()
	pygame.quit()
	sys.exit()


if __name__ == "__main__":
	main()

